<?php
// Author: dr Dave
// URL: http://unknowngenius.com/blog
// Amendments: David Reindl
// URL: http://www.andare.ch/blog/kat/software/
// Version: 1.6b
// License: GPL, all that stuff... see WP license for details.

// READ keitai-prefs.php for instructions

if (function_exists("mb_internal_encoding"))
{
	ini_set("mbstring.internal_encoding", "UTF-8");
	mb_internal_encoding("UTF-8");
}
//phpinfo();

global $my_params, $pic_table_open, $ftp_connection, $max_width, $debug;

ini_set('include_path', dirname(__FILE__) . "/". PATH_SEPARATOR . ini_get('include_path'));

include ("keitai-prefs.php");
$my_params = reset($params);
$my_params['group_start'] = "<table class=\"attachment_table\">";
$my_params['group_end'] = "</table>";
$my_params['text_start'] = "<p class=\"keitai_text\">";
$my_params['text_end'] = "</p>";
$my_params['img_start'] = "<tr><td>";
$my_params['img_end'] = "</td></tr>";

require_once (dirname(__FILE__) . '/mimedecode.php');
require_once (dirname(__FILE__) . '/class-xmlrpc.php');

//if(is_file($my_params['blog_folder']. "/wp-includes/class-xmlrpc.php"))
//	require_once($my_params['blog_folder']. "/wp-includes/class-xmlrpc.php");
//elseif(is_file("class-xmlrpc.php"))
//	require_once "class-xmlrpc.php";

$msg = $input = "";

if(isset($_REQUEST['debug']))
	$debug = $_REQUEST['debug'];
else
	$debug = 2; // change this to enable debugging and output

if ($debug == 0)
{
	ini_set("display_errors", false);
}
else
{
	ini_set("log_errors", true);
	ini_set("error_log", "php_log.txt");
}


if($debug == 3)
{
	$file = fopen ("samplemail.txt", "rb") or die("Can't open samplemail"); 
	while (! feof($file))
		$input .= fread($file, 1024);
}
else
{
	
	if(!defined("STDIN")) 
	{
		$stdin = fopen('php://stdin','rb');
		while($stdin && !feof($stdin) && $i++ < 1000)
			$input .= fread($stdin, 1024);
	}
	else
	{
		while(STDIN && !feof(STDIN) && $i++ < 1000)
			$input .= fread(STDIN, 1024);
	}
}
// debug ****

/**/

if ($debug == 4)
{
	global $mail_log;
	$mail_log = "";
}

if ($debug >= 2)
{
	global $log;
	if (! ($log = fopen("log.txt", "w+")))
		echo "COULD NOT OPEN LOG FILE.";
		
	log_msg("\n=== wp-keitai-mail log ===\n");
	log_msg(date("F j, Y, g:i a") . "\n");
	
	if ($debug != 3)
		ob_start();
}

		
function log_msg ($msg)
{
	global $log, $mail_log, $debug;
	
	if (($debug == 1) || ($debug == 3))
		echo($msg);
		
	if (($debug >= 2) && $log)
		fwrite($log, $msg);
		
	if ($debug == 4)
		$mail_log .= $msg;
}

$ftp_connection = false;

if ($use_ftp) // we try to open now and fail now if impossible... easier to debug that way.
{
	if (! $ftp_connection = ftp_connect($ftp_server))
		die ("Could not connect to ftp server: " . $ftp_server);
	log_msg("New FTP connection: " . $ftp_connection . "\n");
	if (! ftp_login ($ftp_connection, $ftp_login, $ftp_pwd))
		die ("Could not login to ftp server using login: " . $ftp_login);
	log_msg (print_r($ftplist = ftp_nlist($ftp_connection, "."), true));
	if (empty($ftp_path))
		$dirs = explode("/", $my_params['blog_folder']) + explode("/", $my_params['pix_folder']);
	else
		$dirs = explode("/", $ftp_path);
	$start = false;
	foreach ($dirs as $dir)
	{
		if (! $start)
			$start = in_array($dir, $ftplist);
	log_msg("Current dir: $dir\n");	
		if ($start)
			if (! ftp_chdir($ftp_connection, $dir))
				die("Could not change to directory: " . $dir);
	}	
}

$mime_params['include_bodies'] = true;
$mime_params['decode_bodies'] = true;
$mime_params['decode_headers'] = true;
$mime_params['input'] = $input;
$structure = Mail_mimeDecode::decode($mime_params);

	log_msg("MIME Structure: " . print_r($structure, true));

$subject = trim($structure->headers['subject']);
$from = trim($structure->headers['from']);
if (preg_match('/^([^<>]+) ?<([^<>]+)>$/',$from,$matches))
	$from = $matches[2];


if (isset($params[$from]))
{
	foreach ($params[$from] as $key => $val)
		$my_params[$key] = $val;
}
elseif ($enforce_sender)
{
	log_msg ("Sender: '$from' not recognized. Unable to post./n");
	die;
}

if (empty($my_params['login']) || empty($my_params['pwd']) || empty($my_params['cat']))
	log_msg ("No default login/passwd/category provided. Unable to post./n");
else
	log_msg ("Using params: ". print_r($my_params, true));

//print_r($structure);
 $body_array = get_content($structure);
 $body = $body_array[0] . $body_array[1];
if (empty($subject))
	if ($my_params['subject']) $subject = $my_params['subject'];
	else $subject = "Keitai Post";
log_msg ("\nSUBJECT: \n" . $subject . "\nBODY:\n" . $body . "\n");

if (function_exists("mb_detect_encoding") && function_exists("mb_convert_encoding"))
{
	mb_detect_order("auto");
	ini_set("mbstring.detect_order", "auto"); // for some reason, ini_set seems to work where mb_detect_order fails
	mb_detect_order("ASCII, JIS, UTF-8, EUC-JP, SJIS");
	ini_set("mbstring.detect_order", "ASCII, JIS, UTF-8, EUC-JP, SJIS"); // same as above
	
	log_msg("Internal encoding set to: " . mb_internal_encoding() . "\n");

	$encod = mb_detect_encoding($body);
	log_msg ("Current Body Encoding: '" . $encod . "'\n");
	if($encod != "UTF-8")
	{
		log_msg ("Converting Body Encoding to UTF-8\n");
		if (empty($encod))
			$body = mb_convert_encoding($body, "UTF-8");
		else
			$body = mb_convert_encoding($body, "UTF-8", $encod);

	}
	// since we're at it let's do the subject header too
	$encod = mb_detect_encoding($subject);
	log_msg ("Current Subject Encoding: '" . $encod . "'\n");
	if($encod != "UTF-8")
	{
		log_msg ("Converting Subject Encoding to UTF-8\n");
		if (empty($encod))
			$subject = mb_convert_encoding($subject, "UTF-8");
		else
			$subject = mb_convert_encoding($subject, "UTF-8", $encod);

	}
	
}

// $body = preg_replace(array("/<font color=\"[^\"]*\">/i", "/<\/font>/i", "/<\/?li>/i"),
//						 array("{", "}", "\r =", "\r"), 
//						 $body);

ob_start(); // catch all debugging output and silently log it

$myUrl = parse_url($my_params['blog_URL']);

$client = new xmlrpc_client( $myUrl['path']."xmlrpc.php", $myUrl['host']);

$xml_params = array(new xmlrpcval(1, "string"),
				new xmlrpcval($my_params['login']),
				new xmlrpcval($my_params['pwd']),
				new xmlrpcval(array("title" => new xmlrpcval($subject), 
									"description" => new xmlrpcval($body),
				"categories" => new xmlrpcval(array (new xmlrpcval($my_params['cat'])), "array")), "struct"),
				new xmlrpcval(1, "boolean"));

		$msg = new xmlrpcmsg('metaWeblog.newPost', $xml_params);
		$client->setDebug($debug);
		log_msg("Msg sent to xmlrpc: " . print_r($msg, true));
		$result = $client->send($msg);

$stuff = ob_get_contents();
if (($debug == 1) || ($debug == 3))
	ob_end_clean();
log_msg($stuff);

if (!$result->faultCode()) 
{
	$res = $result->value();
	log_msg ("\nSUCCESSFULLY CREATED ENTRY (id: " . $res->getval() . ")\n");
	$reply_sub = "POSTING SUCCESSFUL";
	$reply = "Entry " . $res->getval() . " successfuly posted to your blog.";
} 
else
{
	log_msg ($reply = "Fault:\nCode: " . $result->faultCode() . " Reason '" . $result->faultString() . "'\n");
	$reply_sub = "POSTING FAILED!";
	$reply .= "Debug Trace: $mail_log";
}

if (($debug == 4) || (isset($my_params['mail_confirm']) && ($my_params['mail_confirm'])))
{
	mail($from, $reply_sub, $reply);
}



if ($ftp_connection)
	ftp_quit($ftp_connection);


//tear apart the meta part for useful information
function get_content ($part) 
{
	global $my_params, $pic_table_open, $max_width, $ftp_connection;
	static $i = 0;
	$meta_return =array("", "");
	//global $photosdir;
	//$photosdir = 'wp-photos/';
	log_msg("Part: " . $part->ctype_primary . " / " . $part->ctype_secondary . "\n");
	switch ($part->ctype_primary)
	{
		case 'multipart':
		case 'Multipart':
			log_msg ("Found Multipart: " . (count($part->parts))." parts\n");	
			$meta_return[0] = $meta_return[1] = "";
			foreach ($part->parts as $section)
			{
				$meta_return_add = get_content($section);
				$meta_return[0] .= $meta_return_add[0];
				$meta_return[1] .= $meta_return_add[1];
			}
			if (! empty($meta_return[0]))
				$meta_return[0] = $my_params['group_start'] . $meta_return[0]  . $my_params['group_end'];	
			break;
			
		case 'text':
		case 'Text':
			//dump the enriched stuff
			if ($part->ctype_secondary=='enriched') 
			{
				log_msg ("Enriched part: dumping\n");	
			} 
			else 
			{
				$str = trim($part->body);
				if (!empty($str))
				{
					$meta_return[1] .= $my_params['text_start'];
					if (function_exists("mb_convert_encoding"))
						$meta_return[1] .= mb_convert_encoding($str, "UTF-8");
					else
						$meta_return[1] .= $str;
					$meta_return[1] .= $my_params['text_end'];
					log_msg ("Text part: $meta_return[1] \n");
				}
			}
			break;			


		case 'image':
		case 'Image':
		case 'application':
		case 'Application':
		
			if ($part->ctype_primary == 'application' || $part->ctype_primary == 'Application')
			{
				$ext = strtolower(substr($part->d_parameters['filename'], -4, 4));
				
				if (! in_array($ext, array(".jpg", ".png", ".gif")))
				{
					log_msg ("Not an image attachment ('". $part->d_parameters['filename'] . "'): dumping\n");	
					//log_msg ("Content: ". print_r($part, true) . "\n");	

					break;
				}
				log_msg ("Picture #" . (($i++)+1) ."\n");	
				log_msg ("Filename: " . $filename = $my_params['pix_folder'] . $part->d_parameters['filename'] . "\n");
				if (is_file($my_params['blog_folder'] . $filename))
					do
						$filename = $my_params['pix_folder'] . date("Y-m-d-G-i-g-") . ($i++) . $ext;
					while (is_file($my_params['blog_folder'] . $filename));
			}
			else
			{
				log_msg ("ctype is image. Picture #" . ($i+1) ."\n");	
				do {
					$filename = $my_params['pix_folder'] . date("Y-m-d-G-i-g-") . ($i++) . '.' . $part->ctype_secondary;
					log_msg("Filename: ". $filename . "\n");
				} while (is_file($my_params['blog_folder'] . $filename));
			}
			
			if (! $pic_table_open)
				$pic_table_open = true;

			if ($ftp_connection)
			{
				if (! $tmpfname = tempnam("/tmp", basename($filename)))
					die("Could not create temp file.");
				if (! $fp = fopen($tmpfname, "w+"))
					die ("Could not open temp file: " . $tmpfname);	
				$tmpFile = fwrite($fp, $part->body);
				log_msg("Temp image file created ($tmpFile).\n");
				log_msg("FTP connection: " . $ftp_connection . "\n");
				rewind($fp); 
				if (! ftp_fput($ftp_connection, basename($filename), $fp, FTP_BINARY))
					die ("Could not upload file: " . $filename);	
				$orig_file = $tmpfname;
			}
			else
			{
				$fp = fopen($my_params['blog_folder'] . $filename, 'w');
				fwrite($fp, $part->body);
				chmod($my_params['blog_folder'] . $filename, 0744);
				$orig_file = $my_params['blog_folder'] . $filename;
			}
			
			
			if($max_width && createThumbnail($orig_file, "no", $max_width))
			{
				$meta_return[0] .= $my_params['img_start'] .'<a href="'. $my_params['blog_URL'] . $filename . '" target="_blank" border="0"><img src="' . $my_params['blog_URL'] . dirname($filename) . "/thumbnails/". basename($filename) . '" alt="' . $part->ctype_parameters['name'] . '" /></a>'. $my_params['img_end'];
			}
			else
			{
				$meta_return[0] .= $my_params['img_start']  . '<img src="' . $my_params['blog_URL'] . $filename . '" alt="' . $part->ctype_parameters['name'] . '"/>' . $my_params['img_end'];
			}

			fclose($fp);

		break;
			
	}		
	return $meta_return;
}

function createThumbnail ($myFile, $replace, $maxDim)
{

	global $ftp_connection;

	if (($myFile == "") || !is_file($myFile))
	{
		log_msg ("cannot work with the file provided: $myFile");
		return;
	}
	
	$imageInfo = getimagesize($myFile);
	if (!$imageInfo)
	{
		log_msg ("$myFile doesn't seem to be a valid pict");
		return;
	}
	$src_width = $imageInfo[0]; 
	$src_height = $imageInfo[1]; 

	if ($src_width <= $maxDim && $src_height <= $maxDim) // then we do not need thumbnails
		return false;

	if ($maxDim < 10 || $maxDim > 500)
	{
		log_msg ("the max dimension must be between 10 and 500, you entered $maxDim");
		return;
	}
	
	if ($ftp_connection)
	{
		$destFile = tempnam('/tmp', 'thumb');
		log_msg("destFile: " . $destFile . "\n"); 
		if (! ftp_nlist($ftp_connection, "thumbnails"))
			ftp_mkdir($ftp_connection, "thumbnails");
		if (! ftp_chdir($ftp_connection, "thumbnails"))
			die ("cannot create thumbnail dir. make sure you have privilleges");
	}
	else
	{
		$myDir = dirname($myFile) . "/thumbnails";
		if (! is_dir($myDir))
		{
			mkdir ($myDir);
			chmod ($myDir, 0777);
		}
		$destFile = "$myDir/" . basename($myFile);
		if (is_file($destFile))
		{
			$imageInfo_thumb = getimagesize($destFile);
			if ($imageInfo_thumb)
			{
				$width = $imageInfo_thumb[0]; 
				$height = $imageInfo_thumb[1]; 
			}
			
			if ($replace == "yes")
			{
				if (unlink($destFile))
					$replaced = "(replaced)";
				else
				{
					return array("h" => $height, "w" => $width);
				}
			}
			else
			{
				return array("h" => $height, "w" => $width);
			}
		}
		else
			$replaced = "";
	}
	log_msg("Use $myFile for thumbnail creation.\n");

	if ($src_width > $src_height) {
		$height = round ($src_height * $maxDim / $src_width);
		$width = $maxDim;
	} else {
		$height = $maxDim;
		$width = round ($src_width * $maxDim / $src_height);
	}

	$type = $imageInfo[2];
	
	if ($type == IMAGETYPE_JPEG)
		$src_img = imagecreatefromjpeg ($myFile);
	elseif ($type == IMAGETYPE_PNG)
		$src_img = imagecreatefrompng ($myFile);
	
	if (!$src_img)
	{
		log_msg ("error creating thumbnail: could not load file $myFile<br>");
	}
	else
	{
		if ($width >= $src_width) // do not change if scale >= 1
		{
			$width = $src_width;
			$height = $src_height;
			imagejpeg($src_img, $destFile);
		}
		else
		{
			$dst_img = imagecreatetruecolor($width,$height); 
			imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $width, $height, $src_width, $src_height); 
			if ($type == IMAGETYPE_JPEG)
				imagejpeg($dst_img, $destFile);
			elseif ($type == IMAGETYPE_PNG)
				imagepng($dst_img, $destFile);
			imagedestroy($dst_img);
		}
		imagedestroy($src_img); 
	
		chmod ($destFile, 0777);
	} 	
	
	if ($ftp_connection) {
		if(! ftp_put($ftp_connection, substr(basename($myFile), 0, -6), $destFile, FTP_BINARY))
			die ("Could not upload file");
                if (! ftp_chdir($ftp_connection, "../"))
                        die ("cannot change back to data directory");
	}

	return array("h" => $height, "w" => $width);
}


?>
