<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

	<head>
		<meta http-equiv="content-type" content="text/html;charset=utf-8" />
		<meta name="generator" content="Adobe GoLive" />
		<title>wp-keitai-mail Configuration</title>
		<style type="text/css" media="screen"><!--
body  { color: #474747; font-size: 11px; font-family: Georgia, "Times New Roman", Times, serif; background-color: #f2f2ff }
fieldset { padding: 10px }
li { margin-bottom: 10px }
--></style>
	</head>

	<body bgcolor="#ffffff">
		<div align="center">
			<p><b>Wp-keitai-mail Plugin Configuration</b></p>
		</div>
		<div align="left">
			<form id="FormName" action="" method="get" name="FormName">
			<div class="form_line">
					Thumbnail width: <input type="text" name="textfieldName" size="24"/><i>(set to 0 to disable thumbnail generation)</i>
					<p><input type="checkbox" name="checkboxName" value="checkboxValue" checked="checked"/> Enforce Sender <i>(if enabled: will only accept posts from addresses listed below; will use default settings for unknown addresses otherwise)</i></p>
					<p>
						<fieldset>
							<legend>FTP Options</legend><i>Do not change anything and leave this area disabled unless your mail server is on a separate machine from your WP install.</i>
							<p><input type="checkbox" name="kt_check_use_ftp" value="true"/> Use FTP </p>
							<p>FTP Server: <input type="text" name="kt_ftp_server" size="24"/><i>(e.g. </i>ftp.unknowngenius.com<i>)</i></p>
							<p>FTP Login: <input type="text" name="kt_ftp_login" size="24"/><i>(e.g. </i>drdave<i>)</i></p>
							<p>FTP Password: <input type="text" name="kt_ftp_pwd" size="24"/></p>
						</fieldset>
					</p>
					<p>
						<fieldset>
							<legend>Default Account</legend><i>This is the default account. It sets the default values for the blog to use and different customization options (you will only have to set them again for other accounts if they use different values).</i>
							
							
							<ul>
								<li>Blog URL: <input type="text" name="kt_default_blog_URL" size="24"/><i>(</i><i>it should be automatically detected, edit if necessary)</i></li>
								<li>Blog root folder: <input type="text" name="kt_default_blog_folder" size="24"/><i>(</i><i>this should be the server path to your wp install, edit if necessary)</i></li>
								<li>Picture folder: <input type="text" name="kt_default_pix_folder" size="24"/><i>(this should be the relative path from your wp root folder to a  folder where image files should be stored. You must create one if you do not have one and insure it is writable by the server, i.e. &quot;chmod 777&quot;)</i></li>
								<li>Formatting (the tags below will help you format your entries through CSS. Feel free to get rid of the table entirely for the pictures and use a better CSS layout): 
									<ul>
										<li><b>Image Group:</b> insert HTML before: <input type="text" name="kt_default_group_start" size="24"/>after: <input type="text" name="kt_default_group_end" size="24"/><i>(this HTML will be inserted before and after any group of images, you can leave the default if you are not sure)</i></li>
										<li><b>Image:</b> insert HTML before: <input type="text" name="kt_default_img_start" size="24"/>after: <input type="text" name="kt_default_img_end" size="24"/><i>(this HTML will be inserted before and after any individual image, you can leave the default if you are not sure)</i></li>
										<li><b>Text:</b> insert HTML before: <input type="text" name="kt_default_text_start" size="24"/>after: <input type="text" name="kt_default_text_end" size="24"/><i>(this HTML will be inserted before and after the text part of your email, you can leave the default if you are not sure)</i></li>
									</ul>
								</li>
								<li>Category: <select name="kt_default_cat" size="1">
										<option value="one">first</option>
										<option value="two">second</option>
										<option value="three">third</option>
									</select> <i>(default category to file posts under)</i></li>
								<li>Default Email Account: <input type="text" name="kt_default_email" size="24"/> <i>(the email from which you will be sending your entries)</i></li>
								<li>Blog Login: <select name="kt_default_login" size="1">
										<option value="one">first</option>
										<option value="two">second</option>
										<option value="three">third</option>
									</select> <i>(WP login under which entries will be posted)</i></li>
								<li>Blog Password: <input type="password" name="kt_default_pwd" size="24"/> <i>(WP password)</i></li>
							</ul>
						</fieldset>
					</p>
					<p>
						<fieldset>
							<legend>Account #2</legend>
							<fieldset>
								<legend>Required</legend>
								<ul>
									<li></li>
									<li>Email Account: <input type="text" name="kt_default_email" size="24"/><i>(the email from which you will be sending these entries: leave empty to <b>disable</b> this account)</i></li>
									<li>Blog Login: <select name="kt_default_login" size="1">
											<option value="one">first</option>
											<option value="two">second</option>
											<option value="three">third</option>
										</select> <i>(WP login under which entries will be posted)</i></li>
								</ul>
								<ul>
									<li>Blog Password: <input type="password" name="kt_default_pwd" size="24"/><i>(WP password)</i></li>
									<li>Category: <select name="kt_default_cat" size="1">
											<option value="one">first</option>
											<option value="two">second</option>
											<option value="three">third</option>
										</select> </li>
								</ul>
							</fieldset>
							
							
							
							<p>
								<fieldset>
									<legend>Optional</legend>
									<p><i>Only fill these if you want to override default settings</i></p>
									<ul>
										<li></li>
										<li></li>
										<li>Blog URL: <input type="text" name="kt_default_blog_URL" size="24"/></li>
										<li>Blog root folder: <input type="text" name="kt_default_blog_folder" size="24"/></li>
										<li>Picture folder: <input type="text" name="kt_default_pix_folder" size="24"/><i>(this should be the relative path from your wp root folder to a folder where image files should be stored. You must create one if you do not have one and insure it is writable by the server, i.e. &quot;chmod 777&quot;)</i></li>
										<li>Formatting (the tags below will help you format your entries through CSS. Feel free to get rid of the table entirely for the pictures and use a better CSS layout):
											<ul>
												<li><b>Image Group:</b> insert HTML before: <input type="text" name="kt_default_group_start" size="24"/>after: <input type="text" name="kt_default_group_end" size="24"/><i>(this HTML will be inserted before and after any group of images, you can leave the default if you are not sure)</i></li>
												<li><b>Image:</b> insert HTML before: <input type="text" name="kt_default_img_start" size="24"/>after: <input type="text" name="kt_default_img_end" size="24"/><i>(this HTML will be inserted before and after any individual image, you can leave the default if you are not sure)</i></li>
												<li><b>Text:</b> insert HTML before: <input type="text" name="kt_default_text_start" size="24"/>after: <input type="text" name="kt_default_text_end" size="24"/><i>(this HTML will be inserted before and after the text part of your email, you can leave the default if you are not sure)</i></li>
											</ul>
										</li>
									</ul>
								</fieldset>
							</p>
						</fieldset>
						<input type="submit" name="add_account" value="Add Account"/><input type="submit" name="validate" value="Validate"/></p>
				</div>
			
			</form>
			<p></p>
		</div>
	</body>

</html>